=== build/templates/MEGAShellExtNautilus/PKGBUILD ===
##
 # @file build/MEGAsync/MEGAsync/PKGBUILD
 # @brief script to generate package megasync for ArchLinux
 #
 # (c) 2013-2016 by Mega Limited, Auckland, New Zealand
 #
 # This file is part of the MEGA SDK - Client Access Engine.
 #
 # Applications using the MEGA API must present a valid application key
 # and comply with the the rules set forth in the Terms of Service.
 #
 # The MEGA SDK is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 #
 # @copyright Simplified (2-clause) BSD License.
 #
 # You should have received a copy of the license along with this
 # program.
##

# Maintainer: Pablo Martin <pm@mega.nz>
pkgname=nautilus-megasync
pkgver=EXT_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
epoch=
pkgdesc="MEGA Desktop App plugin for Nautilus"
arch=('i686' 'x86_64')
url=""
license=() #TODO
groups=()
depends=('ca-certificates' 'megasync>=3.5' 'nautilus')
makedepends=( 'ca-certificates' 'qt5-base' 'nautilus' 'libnautilus-extension')
checkdepends=()
optdepends=()
provides=("nautilus-megasync=${pkgver}")
conflicts=()
replaces=()
backup=()
options=(debug strip)
install=megasync.install
changelog= #TODO
source=("./${pkgname}_$pkgver.tar.gz"
)
noextract=()
md5sums=('MD5SUM') # generated with makepkg -g
validpgpkeys=()

prepare() {
	cd "$pkgname-$pkgver"
}

build() {
	#export DESKTOP_DESTDIR=$pkgdir/usr
	cd "$pkgname-$pkgver"
	sed -i "s#update_cache.path = \$\$PWD#update_cache.path = \$\${HICOLOR}#g" MEGAShellExtNautilus.pro
	if [ 0$(pacman -Q nautilus | awk '{print $NF}' | awk -F='-' '{print $1}' | awk -F "." '{FS=".";print $1*10000+$2*100+$3}') -gt 31503 ]; then 
	 echo "NEWER NAUTILUS REQUIRES SMALLER OVERLAY ICONS"
	 for i in data/emblems/64x64/*smaller.png; do mv $i ${i/-smaller/}; done
	else
	 echo "OLDER NAUTILUS DOES NOT REQUIRE SMALLER OVERLAY ICONS"
	 rm data/emblems/64x64/*smaller.png
	fi    
	qmake-qt5 || qmake
	make
}

check() {
	cd "$pkgname-$pkgver"
}

package() {
	cd "$pkgname-$pkgver"
	make install INSTALL_ROOT=$pkgdir
}
