=== build/templates/MEGAsync.debug/PKGBUILD ===
pkgname=megasync-debug
pkgver=MEGASYNC_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
arch=('any')
url="https://mega.nz/#sync"
license=('Freeware')
pkgdesc="Get more control over your data"
depends=(
'qt4'
'openssl'
'sqlite'
'c-ares'
'crypto++'
'ca-certificates'
)
